VERSION 5.00
Begin VB.UserControl LynxFace 
   ClientHeight    =   1395
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1695
   Picture         =   "LynxFace.ctx":0000
   ScaleHeight     =   1395
   ScaleWidth      =   1695
End
Attribute VB_Name = "LynxFace"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' ------------------------------------------------------------------------------
'
' LynxFace(LynxFace.ctl)                                  Ulrich Mller 18.01.01
'                                                         Procida 400NT    VB6.0
' LynxFace Control 1.0
'
' ------------------------------------------------------------------------------

Option Explicit

Public Event OnLynxPosition()

Public Enum lyxKonstanten
  lyxFehler = &H1FFFF
End Enum

Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Private Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer
Private Const VK_ESCAPE = &H1B

' --- COM-Port Declares 32bit ------------------------------------------

Private Declare Function CloseHandle Lib "kernel32" _
   (ByVal hObject As Long) As Long
Private Declare Function CreateFile Lib "kernel32" _
    Alias "CreateFileA" (ByVal lpFileName As String, _
    ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, _
    ByVal lpSecurityAttributes As Long, ByVal dwCreationDisposition As Long, _
    ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Private Declare Function WriteFile Lib "kernel32" _
    (ByVal hFile As Long, ByVal lpBuffer As Any, _
    ByVal nNumberOfBytesToWrite As Long, _
    lpNumberOfBytesWritten As Long, lpOverlapped As OVERLAPPED) As Long
Private Declare Function GetCommState Lib "kernel32" _
    (ByVal nCid As Long, lpDCB As dcbType) As Long
Private Declare Function SetCommState Lib "kernel32" _
    (ByVal hCommDev As Long, lpDCB As dcbType) As Long
Private Declare Function SetCommTimeouts Lib "kernel32" _
    (ByVal hFile As Long, lpCommTimeouts As COMMTIMEOUTS) As Long
  
' ------------------ Konstanten dazu --------------------------------------
  
Private Const GENERIC_READ = &H80000000
Private Const GENERIC_WRITE = &H40000000
Private Const INVALID_HANDLE_VALUE = -1
Private Const OPEN_EXISTING = 3

Private Const NOPARITY = 0
Private Const ONESTOPBIT = 0
  
' --------------- Type-Declares und Variable ---------------------------
  
Private Type dcbType    ' --- Win32API.TXT is incorrect here.
  DCBlength As Long
  BaudRate As Long
  Bits1 As Long
  wReserved As Integer
  XonLim As Integer
  XoffLim As Integer
  ByteSize As Byte
  Parity As Byte
  StopBits As Byte
  XonChar As Byte
  XoffChar As Byte
  ErrorChar As Byte
  EofChar As Byte
  EvtChar As Byte
  wReserved2 As Integer
End Type
  
Private Type COMMTIMEOUTS
  ReadIntervalTimeout As Long
  ReadTotalTimeoutMultiplier As Long
  ReadTotalTimeOutConstant As Long
  WriteTotalTimeoutMultiplier As Long
  WriteTotalTimeoutConstant As Long
End Type
  
Private Type OVERLAPPED
  Internal As Long
  InternalHigh As Long
  Offset As Long
  OffsetHigh As Long
  hEvent As Long
End Type

' --------- Globale Variable in LynxFace ----------------------------

Private comI As Long                    ' --- Handle fr COM-Port
Private comIDCB As dcbType              ' --- DCB des COM-Ports
Private comITimeOuts As COMMTIMEOUTS    ' --- Controlblock fr Timeouts
Private overL As OVERLAPPED             ' --- Overlapped Dummy
Private ComName$

Private FSrvDelay&, FSrvStep&
Private FNotHalt As Boolean
Private aktPos(0 To 4) As Long


Public Function CloseController() As Long

' --- Schlieen ComPort  -----------

  Sleep 50
  CloseHandle (comI)
  ComName = ""
  CloseController = 0
  
End Function

Public Function DriveTo(ByVal ServNr&, ByVal Pos&) As Long

Dim i&, xStep&

  DriveTo = lyxFehler
  If Pos < aktPos(ServNr) Then xStep = -SrvStep Else xStep = SrvStep
  For i = aktPos(ServNr) To Pos Step xStep
    If FNotHalt Or (GetAsyncKeyState(VK_ESCAPE) <> 0) Then Exit Function
    If PosMotor(ServNr, i) = lyxFehler Then Exit Function
    If SrvDelay > 0 Then Sleep SrvDelay
  Next i
  If PosMotor(ServNr, Pos) = lyxFehler Then Exit Function
  aktPos(ServNr) = Pos
  RaiseEvent OnLynxPosition
  DoEvents
  DriveTo = 0
  
End Function


Private Function MoveBasis(P&()) As Long

' --------- simultanes Anfahren einer vorgegebenen Position --------
'   aktuelle Position in aktPos(), Zielposition in P()
'   die Zielposition wird fr alle Server simultan in SrvStep angefahren
'   nach jedem Fahrbefehl ggf. eine Pause

Dim i&, aktiv As Boolean

  MoveBasis = lyxFehler
    
' ----------------- Positionswerte begrenzen --------
  For i = 0 To 3
    If P(i) < 1 Then P(i) = 1
    If P(i) > 254 Then P(i) = 254
  Next i
  
' ------------- Schleife bis es nicht mehr zu fahren gibt ---------

  Do
    aktiv = False
' ------------------ Schleife ber die ServerMotoren ----------
    For i = 0 To 3
      If FNotHalt Or (GetAsyncKeyState(VK_ESCAPE) <> 0) Then Exit Function
      If P(i) < aktPos(i) Then
        aktPos(i) = aktPos(i) - FSrvStep
        If PosMotor(i, aktPos(i)) = lyxFehler Then Exit Function
        If FSrvDelay > 0 Then Sleep FSrvDelay
        aktiv = True
      ElseIf (P(i) - FSrvStep) > aktPos(i) Then
        aktPos(i) = aktPos(i) + FSrvStep
        If PosMotor(i, aktPos(i)) = lyxFehler Then Exit Function
        If FSrvDelay > 0 Then Sleep FSrvDelay
        aktiv = True
      End If
    Next i
  Loop While aktiv
  
' --------------------- Korrektur auf Endposition ---------------

  For i = 0 To 3
    If FNotHalt Or (GetAsyncKeyState(VK_ESCAPE) <> 0) Then Exit Function
    If PosMotor(i, P(i)) = lyxFehler Then Exit Function
    aktPos(i) = P(i)
  Next i
  
' ----------------- Ende -------------------------------

  RaiseEvent OnLynxPosition
  DoEvents
  MoveBasis = 0
  
End Function

Public Function MoveTo(ByVal P0&, ByVal P1&, ByVal P2&, ByVal P3&)

' ---------------- simultanes Anfahren einer neuen abs. Position -----

Dim P&(0 To 3)

  P(0) = P0
  P(1) = P1
  P(2) = P2
  P(3) = P3
  MoveTo = MoveBasis(P)
  
End Function


Public Property Let NotHalt(Wert As Boolean)

  FNotHalt = Wert
  
End Property

Public Property Get NotHalt() As Boolean

  NotHalt = FNotHalt
  
End Property

Public Function OpenController(ComName$) As Long

' --- Initalisieren des Interfaces ----

Dim res&, i&

  OpenController = lyxFehler
  
' --- Anlegen eines ComPort-Files --------------
'     Lesen und Schreiben zulssig, exklusiv, keine Security,
'     mu vorh. sein, normale Attribute (kein Overlapp),kein Tempfile

  overL.hEvent = 0
  overL.Offset = 0
  overL.OffsetHigh = 0
  
  comI = CreateFile(ComName, GENERIC_READ Or GENERIC_WRITE, 0, 0, _
    OPEN_EXISTING, 0&, 0)
  If comI = INVALID_HANDLE_VALUE Then Exit Function
  
' --- ModemSettings ----

  res = GetCommState(comI, comIDCB)
  
  comIDCB.BaudRate = 9600
  comIDCB.ByteSize = 8
  comIDCB.Parity = NOPARITY
  comIDCB.StopBits = ONESTOPBIT
  
  res = SetCommState(comI, comIDCB)
  
' --- TimeOuts einstellen : pro gelesenes Byte 4 ms + 30 ms gesamt ---

  comITimeOuts.ReadIntervalTimeout = 5
  comITimeOuts.ReadTotalTimeoutMultiplier = 4
  comITimeOuts.ReadTotalTimeOutConstant = 30
  comITimeOuts.WriteTotalTimeoutMultiplier = 1
  comITimeOuts.WriteTotalTimeoutConstant = 10
  res = SetCommTimeouts(comI, comITimeOuts)

'  If res <> 0 Then Exit Function
  For i = 0 To 4
    aktPos(i) = 127
    PosMotor i, 127
  Next i
  FNotHalt = False
  OpenController = 0

End Function

Public Property Get Position(ByVal i&) As Long

  Position = aktPos(i)
  
End Property

Private Function PosMotor(ByVal svrNr&, ByVal Pos&) As Long

' --- Refresh des MotorenStatus und Abfrage des Eingabestatus

Dim res&, w&

' --- String, Stringlnge, tatschliche Bytes, nicht overlapped

  If Pos < 1 Then Pos = 1
  If Pos > 254 Then Pos = 254
  res = WriteFile(comI, Chr$(255) & Chr$(svrNr) & Chr$(Pos), 3, w, overL)
  
  If res = 0 Then PosMotor = lyxFehler Else PosMotor = 0
 
End Function


Public Property Let SrvDelay(ByVal Wert As Long)

  If Wert < 0 Then Wert = 0
  If Wert > 100 Then Wert = 100
  FSrvDelay = Wert
  
End Property

Public Property Get SrvDelay() As Long

  SrvDelay = FSrvDelay
  
End Property

Public Property Let SrvStep(ByVal Wert&)

  If Wert < 1 Then Wert = 1
  If Wert > 10 Then Wert = 10
  FSrvStep = Wert
  
End Property

Public Property Get SrvStep() As Long

  SrvStep = FSrvStep
  
End Property

Private Sub UserControl_Initialize()

  FSrvDelay = 1
  FSrvStep = 2
  
End Sub


Private Sub UserControl_Terminate()

  CloseController
  
End Sub


