VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "HanoiRob"
   ClientHeight    =   3405
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3765
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "LynxHanoi.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   3405
   ScaleWidth      =   3765
   StartUpPosition =   3  'Windows-Standard
   Begin LynxHanoi.LynxFace lx 
      Height          =   1335
      Left            =   1920
      TabIndex        =   3
      Top             =   120
      Width           =   1695
      _ExtentX        =   2990
      _ExtentY        =   2355
   End
   Begin VB.CommandButton cmdEnde 
      Caption         =   "ENDE"
      Height          =   375
      Left            =   2280
      TabIndex        =   1
      Top             =   2400
      Width           =   1335
   End
   Begin VB.CommandButton cmdAction 
      Caption         =   "START"
      Height          =   375
      Left            =   2280
      TabIndex        =   0
      Top             =   2880
      Width           =   1335
   End
   Begin VB.Label lblStatus 
      Alignment       =   2  'Zentriert
      Caption         =   "0"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   300
      Left            =   360
      TabIndex        =   2
      Top             =   1800
      Width           =   3015
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' ------------------------------------------------------------------------------
'
' frmMain(LynxHanoi.frm)                                  Ulrich Mller 21.01.01
'                                                         Procida 400NT    VB6.0
' Turm von Hanoi mit LynxMotion 3 Axis Robot
'
' ------------------------------------------------------------------------------

Option Explicit

Private Type Turm
  AnzScheiben As Long
  Position As Long
End Type

Private Type Scheibe
  OberarmPosition As Long
  UnterarmPosition As Long
  HandPosition As Long
End Type

Const Scheiben = 4
Const hanSaule = 0, hanPosA = 0, hanPosB = 1, hanPosC = 2
Const hanOberarm = 1, hanOberarmOben = 16
Const hanUnterarm = 2, hanUnterarmOben = 22
Const hanHand = 3, hanHandOben = 127
Const hanGreifer = 4, hanGreiferZu = 121, hanGreiferAuf = 156

Dim PortName$
Dim Turme(0 To 2) As Turm
Dim ScheibenPosition(0 To 10) As Scheibe

Private Sub ArmHeben(ByVal Pos&)

  lx.MoveTo lx.Position(0), hanOberarmOben, hanUnterarmOben, hanHandOben
  
End Sub

Private Sub ArmSenken(ByVal Pos&, ByVal i&)

  lx.MoveTo lx.Position(0), ScheibenPosition(i).OberarmPosition, _
                            ScheibenPosition(i).UnterarmPosition, _
                            ScheibenPosition(i).HandPosition
  
End Sub

Private Sub Hanoi(ByVal n&, ByVal PosA&, ByVal PosB&, ByVal PosC&)

  If n = 1 Then
    Ziehe PosA, PosB
  Else
    Hanoi n - 1, PosA, PosC, PosB
    Ziehe PosA, PosB
    Hanoi n - 1, PosC, PosB, PosA
  End If
  
End Sub

Private Sub Hole(ByVal Pos&)

  SauleNach Pos
  ArmSenken Pos, Turme(Pos).AnzScheiben - 1
  ScheibeGreifen Pos
  ArmHeben Pos
  
End Sub

Private Sub Init()
  
  Turme(0).AnzScheiben = Scheiben
  Turme(0).Position = 90
  Turme(1).AnzScheiben = 0
  Turme(1).Position = 127
  Turme(2).AnzScheiben = 0
  Turme(2).Position = 165
  
  lx.NotHalt = False
  lx.MoveTo Turme(0).Position, ScheibenPosition(Scheiben - 1).OberarmPosition, _
                              ScheibenPosition(Scheiben - 1).UnterarmPosition, _
                              ScheibenPosition(Scheiben - 1).HandPosition
  lx.DriveTo hanGreifer, hanGreiferAuf
  MsgBox "Turm auf Ausgangsposition stellen (oberster Scheibengriff in geffneten Greifer)", vbOKOnly + vbExclamation, App.ProductName
  
End Sub


Private Sub SauleNach(ByVal Pos&)

  lx.DriveTo hanSaule, Turme(Pos).Position
  
End Sub

Private Sub ScheibeGreifen(ByVal Pos&)

  lx.DriveTo hanGreifer, hanGreiferZu
  Turme(Pos).AnzScheiben = Turme(Pos).AnzScheiben - 1
  
End Sub

Private Sub ScheibeLegen(ByVal Pos&)
  
  Turme(Pos).AnzScheiben = Turme(Pos).AnzScheiben + 1
  lx.DriveTo hanGreifer, hanGreiferAuf
  
End Sub


Private Sub Setze(ByVal Pos&)

  SauleNach Pos
  ArmSenken Pos, Turme(Pos).AnzScheiben
  ScheibeLegen Pos
  ArmHeben Pos
  
End Sub


Private Sub Ziehe(ByVal PosA&, ByVal PosB&)

  lblStatus.Caption = PosA & " nach " & PosB
  Hole PosA
  Setze PosB
  
End Sub

Private Sub cmdAction_Click()

  Init
  Hanoi Scheiben, hanPosA, hanPosB, hanPosC
  lx.MoveTo lx.Position(0), 172, 77, 167
  lblStatus.Caption = "Fertig"
  cmdEnde.SetFocus
  
End Sub


Private Sub cmdEnde_Click()

  Unload Me
  
End Sub


Private Sub Form_Load()

  Me.Caption = App.ProductName

' ----- OpenInterface ---------

  If Command$ = "" Then
    PortName = InputBox("Bitte PortNamen eingeben (COM1 - COM9)", App.ProductName, "COM1")
  Else
    PortName = Command$
  End If
  
  lx.SrvDelay = 1
  lx.SrvStep = 1
  
  If lx.OpenController(PortName) = lyxFehler Then
    MsgBox "Controller-Problem", vbCritical + vbOKOnly, App.ProductName
    Exit Sub
  End If
  
' --- Besetzen der Motorenliste, nur Abweichungen vom Default ---

  ScheibenPosition(0).OberarmPosition = 15
  ScheibenPosition(0).UnterarmPosition = 98
  ScheibenPosition(0).HandPosition = 167
  ScheibenPosition(1).OberarmPosition = 15
  ScheibenPosition(1).UnterarmPosition = 86
  ScheibenPosition(1).HandPosition = 167
  ScheibenPosition(2).OberarmPosition = 28
  ScheibenPosition(2).UnterarmPosition = 87
  ScheibenPosition(2).HandPosition = 167
  ScheibenPosition(3).OberarmPosition = 27
  ScheibenPosition(3).UnterarmPosition = 77
  ScheibenPosition(3).HandPosition = 167
   
End Sub


Private Sub Form_Unload(Cancel As Integer)

  lx.NotHalt = True
  lx.CloseController
  
End Sub


